#include "ofxStepperMotors.h"

ofxStepperMotors::ofxStepperMotors(){}
//ofxStepperMotors::~ofxStepperMotors(){}
void ofxStepperMotors::connectArduino(string port,int baudRate){
serial.setup(port,baudRate);
}
void ofxStepperMotors::setupMotors(string name,int stepPerRevolution){

    motor m;
    m.motorName=name;
    m.motorState=INACTIVE;
    m.stepPerRevolution=stepPerRevolution;
    m.target=0;
    motors.push_back(m);
}

void ofxStepperMotors::update(){


    //RECEIVE SERIAL
    string str = ofxGetSerialString(serial, '\n');

    if (str=="") {
    } else {
    cout<<"receive"<<str<<endl;
    vector<string>splitString=ofSplitString(str,":");
    //splitString=ofSplitString(str,":");

    if(str=="donepos")
        {

        }
    }


}

void ofxStepperMotors::step(int steps,int motorN,bool direction){

if(motorN<motors.size()){
motors[motorN].target=steps;
if(direction==ANTICLOCKWISE){
motors[motorN].target=-steps;
}


}else{
cout<<"motor not set up"<<endl;
}

}

void ofxStepperMotors::step(int steps,string motorName,bool direction){

}

void ofxStepperMotors::stepWithAngle(int angle,int motorN, bool direction){

}

void ofxStepperMotors::stepWithAngle(int angle,string motorName, bool direction){

}

int ofxStepperMotors::getAngle(int motorN){

}
int ofxStepperMotors::getAngle(string motorName){

}
int ofxStepperMotors::getStep(int motorN){

}
int ofxStepperMotors::getStep(string motorName){

}



void ofxStepperMotors::send(bool overRideCommand){
sendSerial(overRideCommand);
}



void ofxStepperMotors::sendSerial(bool overRide){

        //string send=ofToString((int)customX)+","+ofToString((int)customY)+","+ofToString((int)customZ)+".";
       // string resetS;
        string send="";

if(overRide==false){
for(int i=0;i<motors.size();i++){


    send+=ofToString((long)motors[i].target)+",";

}
}else{
for(int i=0;i<motors.size();i++){

    if(motors[i].motorState==INACTIVE){
    send+=ofToString((long)motors[i].target)+",";
    }
    else
    {
    string pos=ofToString(getStep(i));
    send+=pos+",";
    }
}
}
send=send.substr(0, send.size()-1);//delete the last char

send+="n";

      //cout<<"sent to arduino buffer: "<<send<<endl;
		char buffer[1024];
        strncpy(buffer, send.c_str(), sizeof(buffer));
        buffer[sizeof(buffer) - 1] = 0;
		 for(int i=0;i<send.size();i++){
            cout<<"write byte"<<buffer[i]<<endl;
            serial.writeByte(buffer[i]);
		 }


}



///COM
string ofxStepperMotors::ofxGetSerialString(ofSerial &serial, char until) {
    static string str;
    stringstream ss;
    char ch;
    int ttl=1000;
    while ((ch=serial.readByte())>0 && ttl-->0 && ch!=until) {
        ss << ch;
    }
    str+=ss.str();
    if (ch==until) {
        string tmp=str;
        str="";
        return ofxTrimString(tmp);
    } else {
        return "";
    }
}

///COM
string ofxStepperMotors::ofxTrimStringRight(string str) {
    size_t endpos = str.find_last_not_of(" \t\r\n");
    return (string::npos != endpos) ? str.substr( 0, endpos+1) : str;
}

// trim trailing spaces
string ofxStepperMotors::ofxTrimStringLeft(string str) {
    size_t startpos = str.find_first_not_of(" \t\r\n");
    return (string::npos != startpos) ? str.substr(startpos) : str;
}

string ofxStepperMotors::ofxTrimString(string str) {
    return ofxTrimStringLeft(ofxTrimStringRight(str));;
}
